export class AsyncOperationsState {
    constructor(failed, pending) {
        this.failed = failed;
        this.pending = pending;
    }
    static empty() {
        return new AsyncOperationsState([], []);
    }
    start(action) {
        return new AsyncOperationsState(this.failed, [...this.pending, action]);
    }
    fail(action) {
        return new AsyncOperationsState([...this.failed, action], this.pending.filter(({ id }) => id !== action.id));
    }
    done(action) {
        return this.removePending(action.id);
    }
    removePending(actionId) {
        return new AsyncOperationsState(this.failed, this.pending.filter(({ id }) => id !== actionId));
    }
    removeFailed(actionId) {
        return new AsyncOperationsState(this.failed.filter(({ id }) => id !== actionId), this.pending);
    }
}
//# sourceMappingURL=state.js.map