import { Maybe } from 'monet';
import { combineReducers } from 'redux';
import { DISPATCH, ENHANCE_DISPATCHER, REDUCERS } from './tokens';
export class Reducer {
    constructor(state) {
        this.state = state;
        this.reduce = this.reduce.bind(this);
    }
    static applyReducers(reducers) {
        return (next) => (reducer, preloadedState) => {
            const store = next(reducer, preloadedState);
            reducers.forEach(one => {
                one[ENHANCE_DISPATCHER](store.dispatch);
            });
            return store;
        };
    }
    static combineReducers(reducers) {
        return combineReducers(reducers.map(one => one.reduce).toObject());
    }
    reduce(state, { args, type }) {
        // tslint:disable-next-line:no-object-mutation
        this.state = Maybe.fromNull(state).orJust(this.state);
        Maybe.fromNull(this[REDUCERS].get(type)).forEach(reduction => reduction.apply(this, args));
        return this.state;
    }
    [ENHANCE_DISPATCHER](dispatch) {
        // tslint:disable-next-line:no-object-mutation
        this[DISPATCH] = dispatch;
    }
}
//# sourceMappingURL=reducer.js.map