"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@samwise-tech/core");
var uuid = require("uuid");
var tokens_1 = require("../reducer-dispatcher/tokens");
var dispatcher_1 = require("./dispatcher");
var getAction = 
// tslint:disable-next-line:readonly-array
function (id, name, args) { return ({
    args: args,
    id: id,
    name: name,
    type: dispatcher_1.AsyncOperationsDispatcher.ACTION,
}); };
var getStartAction = function (base) { return (tslib_1.__assign({}, base, { status: core_1.RequestState.Start })); };
var getFailAction = function (base, reason) { return (tslib_1.__assign({}, base, { reason: reason, status: core_1.RequestState.Fail })); };
var getDoneAction = function (base, data) { return (tslib_1.__assign({}, base, { data: data, status: core_1.RequestState.Success })); };
exports.asyncFactory = function (dispatcher) {
    return function (name, isWrappedEither) {
        if (isWrappedEither === void 0) { isWrappedEither = true; }
        return function (_targetProto, propName, descriptor) {
            var original = descriptor.value;
            // tslint:disable-next-line:no-object-mutation
            descriptor.value = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var action = getAction(propName + ":async:" + uuid.v4(), name, args);
                dispatcher[tokens_1.DISPATCH](getStartAction(action));
                var promise = original.apply(this, args);
                if (isWrappedEither) {
                    promise.then(function (resolved) {
                        resolved.cata(function (reason) {
                            dispatcher[tokens_1.DISPATCH](getFailAction(action, reason));
                        }, function (response) {
                            dispatcher[tokens_1.DISPATCH](getDoneAction(action, response));
                        });
                    }, function (reason) {
                        dispatcher[tokens_1.DISPATCH](getFailAction(action, reason));
                    });
                }
                else {
                    promise.then(function (response) {
                        dispatcher[tokens_1.DISPATCH](getDoneAction(action, response));
                    }, function (reason) {
                        dispatcher[tokens_1.DISPATCH](getFailAction(action, reason));
                    });
                }
                return promise;
            };
        };
    };
};
exports.async = exports.asyncFactory(dispatcher_1.AsyncOperationsDispatcher.instance());
//# sourceMappingURL=async.js.map