import { IAsyncOperationsDoneAction, IAsyncOperationsFailAction, IAsyncOperationsStartAction } from './action';
export declare class AsyncOperationsState {
    readonly failed: ReadonlyArray<IAsyncOperationsFailAction>;
    readonly pending: ReadonlyArray<IAsyncOperationsStartAction>;
    static empty(): AsyncOperationsState;
    constructor(failed: ReadonlyArray<IAsyncOperationsFailAction>, pending: ReadonlyArray<IAsyncOperationsStartAction>);
    start(action: IAsyncOperationsStartAction): AsyncOperationsState;
    fail(action: IAsyncOperationsFailAction): AsyncOperationsState;
    done(action: IAsyncOperationsDoneAction): AsyncOperationsState;
    removePending(actionId: string | Symbol): AsyncOperationsState;
    removeFailed(actionId: string | Symbol): AsyncOperationsState;
}
