"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncOperationsState = /** @class */ (function () {
    function AsyncOperationsState(failed, pending) {
        this.failed = failed;
        this.pending = pending;
    }
    AsyncOperationsState.empty = function () {
        return new AsyncOperationsState([], []);
    };
    AsyncOperationsState.prototype.start = function (action) {
        return new AsyncOperationsState(this.failed, this.pending.concat([action]));
    };
    AsyncOperationsState.prototype.fail = function (action) {
        return new AsyncOperationsState(this.failed.concat([action]), this.pending.filter(function (_a) {
            var id = _a.id;
            return id !== action.id;
        }));
    };
    AsyncOperationsState.prototype.done = function (action) {
        return this.removePending(action.id);
    };
    AsyncOperationsState.prototype.removePending = function (actionId) {
        return new AsyncOperationsState(this.failed, this.pending.filter(function (_a) {
            var id = _a.id;
            return id !== actionId;
        }));
    };
    AsyncOperationsState.prototype.removeFailed = function (actionId) {
        return new AsyncOperationsState(this.failed.filter(function (_a) {
            var id = _a.id;
            return id !== actionId;
        }), this.pending);
    };
    return AsyncOperationsState;
}());
exports.AsyncOperationsState = AsyncOperationsState;
//# sourceMappingURL=state.js.map