"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var monet_1 = require("monet");
var redux_1 = require("redux");
var tokens_1 = require("./tokens");
var Reducer = /** @class */ (function () {
    function Reducer(state) {
        this.state = state;
        this.reduce = this.reduce.bind(this);
    }
    Reducer.applyReducers = function (reducers) {
        return function (next) {
            return function (reducer, preloadedState) {
                var store = next(reducer, preloadedState);
                reducers.forEach(function (one) {
                    one[tokens_1.ENHANCE_DISPATCHER](store.dispatch);
                });
                return store;
            };
        };
    };
    Reducer.combineReducers = function (reducers) {
        return redux_1.combineReducers(reducers.map(function (one) { return one.reduce; }).toObject());
    };
    Reducer.prototype.reduce = function (state, _a) {
        var _this = this;
        var args = _a.args, type = _a.type;
        // tslint:disable-next-line:no-object-mutation
        this.state = monet_1.Maybe.fromNull(state).orJust(this.state);
        monet_1.Maybe.fromNull(this[tokens_1.REDUCERS].get(type)).forEach(function (reduction) { return reduction.apply(_this, args); });
        return this.state;
    };
    Reducer.prototype[tokens_1.ENHANCE_DISPATCHER] = function (dispatch) {
        // tslint:disable-next-line:no-object-mutation
        this[tokens_1.DISPATCH] = dispatch;
    };
    return Reducer;
}());
exports.Reducer = Reducer;
//# sourceMappingURL=reducer.js.map